﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.IO;


namespace Kresleni
{
    public partial class Okno : Form
    {
        private Bitmap bitmap;

        private MyArea area;

        public Okno()
        {
            InitializeComponent();
            int w = pictureBox.Width;
            int h = pictureBox.Height;
            bitmap = new Bitmap(w, h);
            Graphics g = Graphics.FromImage(bitmap);
            g.FillRectangle (Brushes.White, 0, 0, w-1, h-1);
            pictureBox.Image = bitmap;
            // pictureBox.Invalidate();

            toolComboBox.SelectedIndex = 1;

            area = new MyArea(this);
        }


        private void addMyPanelToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MyPanel p = new MyPanel (area);
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            TreeNode node = treeView1.SelectedNode;
            if (node != null)
                propertyGrid1.SelectedObject = node.Tag;
            else
                propertyGrid1.SelectedObject = null;
        }

        private void selector_SelectedIndexChanged(object sender, EventArgs e)
        {
            /*
            if (selector.SelectedIndex == 0)
                propertyGrid1.SelectedObject = myPanel1;
            else if (selector.SelectedIndex == 1)
                propertyGrid1.SelectedObject = myPanel1.button1;
             */
        }

        int X0, Y0;
        bool stisknuto = false;

        private void pictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            stisknuto = true;
            X0 = e.X;
            Y0 = e.Y;
        }

        private void pictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (stisknuto)
            {
                Graphics g = Graphics.FromHwnd(pictureBox.Handle);

                int X1 = e.X;
                int Y1 = e.Y;

                int X = X0 < X1 ? X0 : X1;
                int Y = Math.Min(Y0, Y1);

                int W = Math.Abs(X0 - X1);
                int H = Math.Abs(Y0 - Y1);

                Pen pen = new Pen(penColor);

                g.DrawImage(pictureBox.Image, new Point(0, 0));
            }
        }

        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            if (stisknuto)
            {
                stisknuto = false;
                Graphics g = Graphics.FromImage(pictureBox.Image);
                int X1 = e.X;
                int Y1 = e.Y;

                int X = X0 < X1 ? X0 : X1;
                int Y = Math.Min (Y0, Y1); 

                int W = Math.Abs (X0 - X1);
                int H = Math.Abs (Y0 - Y1);

                Brush b = null;

                if (colorCheckBox.Checked)
                {
                    // using System.Drawing.Drawing2D;
                    b = new LinearGradientBrush
                        (new Point(X, Y), new Point(X + W - 1, Y + H - 1),
                         color, color2);
                }
                else
                {
                    b = new SolidBrush(color);
                }

                Pen pen = new Pen(penColor);
                pen.Width = 5;

                string s = toolComboBox.Text;
                int n = toolComboBox.SelectedIndex;

                if (n == 0)
                {
                     g.FillRectangle(b, X, Y, W, H);
                     g.DrawRectangle(pen, X, Y, W, H);
                }
                else if (n == 1)
                {
                    g.FillEllipse(b, X, Y, W, H);
                    g.DrawEllipse(pen, X, Y, W, H);
                }
                else if (n == 2)
                {
                    float start = 0;
                    float end = (float)numericField.Value;
                    g.FillPie (b, X, Y, W, H, start, end);
                    g.DrawPie (pen, X, Y, W, H, start, end);
                }

                pictureBox.Invalidate();
            }
        }

        private Color penColor = Color.Yellow;
        private Color color = Color.Blue;
        private Color color2 = Color.Red;

        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {
            Control p = (Control) sender;
            if (e.Button == MouseButtons.Right)
                penColor = p.BackColor;
            else if (e.Button == MouseButtons.Middle)
                color2 = p.BackColor;
            else
                color = p.BackColor;
        }

        private void panel1_DoubleClick(object sender, EventArgs e)
        {
            Control p = (Control)sender;
            colorDialog.Color = p.BackColor;
            if (colorDialog.ShowDialog() == DialogResult.OK)
            {
                p.BackColor = colorDialog.Color;
                color = p.BackColor;
            }
        }

        int panel_cnt = 0;

        private void addColorPanelToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Panel p = new Panel ();
            
            // p.Parent = toolPanel;
            toolPanel.Controls.Add(p);

            p.BackColor = Color.CornflowerBlue;

            p.Width = panel3.Width;
            p.Height = panel3.Height;

            panel_cnt ++;
            p.Left = panel3.Left + panel_cnt * (panel3.Left - panel2.Left);
            p.Top = panel3.Top;

            p.MouseDown += panel1_MouseDown;
            p.DoubleClick += panel1_DoubleClick;

            // p.Show ();
        }

        private void pictureBox_SizeChanged(object sender, EventArgs e)
        {
            int w = Math.Max (pictureBox.Width, pictureBox.Image.Width);
            int h = Math.Max (pictureBox.Height, pictureBox.Image.Height);

            Bitmap b = new Bitmap(w, h);
            Graphics g = Graphics.FromImage(b);
            g.FillRectangle(Brushes.White, 0, 0, w-1, h-1);
            g.DrawImage(pictureBox.Image, new Point(0, 0));
            bitmap = b;
            pictureBox.Image = bitmap;
        }

        private void ScanFiles(DirectoryInfo d)
        {
            fileList.Items.Clear();
            if (d != null)
            {
                /*
                FileInfo[] files = null;
                try
                {
                    d.GetFiles();
                }
                catch (Exception ex)
                { 
                }
                */
                FileInfo[] files = d.GetFiles();

                foreach (FileInfo f in files)
                {
                   ListViewItem item = new ListViewItem();
                   item.Text = f.Name;
                   item.ToolTipText = f.FullName;
                   item.SubItems.Add("" + f.Length);
                   item.SubItems.Add(f.LastWriteTime.ToString("dd-MM-yyyy HH:mm4"));
                   // item.SubItems.Add(f.LastWriteTime.ToString());

                   fileList.Items.Add(item);
                }
            }
        }

        private void ScanReal(TreeNode n, DirectoryInfo d, int level)
        {
            if (level > 1)
            {
                DirectoryInfo[] subdirs = d.GetDirectories();
                if (subdirs != null)
                    for (int i = 0; i < subdirs.Length; i++)
                        ScanSub(n, subdirs[i], level - 1);
            }
        }

        private void ScanSub(TreeNode top, DirectoryInfo d, int level)
        {
            TreeNode n = new TreeNode();
            n.Text = d.Name;
            n.ToolTipText = d.FullName;
            n.Tag = d;

            ScanReal(n, d, level);

            if (top != null)
                top.Nodes.Add(n);
            else
                directoryTree.Nodes.Add(n);
        }

        private void ScanDirectory(TreeNode top, string dirName, int level)
        {
            // using System.IO;
            DirectoryInfo d = new DirectoryInfo (dirName);
            ScanSub(top, d, level);
        }

        private void testDirectoriesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            directoryTree.Nodes.Clear();
            fileList.Items.Clear();

            // ScanDirectory (null, "C:\\Work");
            DriveInfo [] drives = DriveInfo.GetDrives ();
            foreach (DriveInfo drive in drives)
            {
                if (drive.DriveType == DriveType.Fixed ||
                    drive.DriveType == DriveType.CDRom )
                   if (drive.IsReady)
                      ScanDirectory(null, drive.Name, 2);
            }


            tabControl1.SelectedTab = directoryPage;
            tabControl2.SelectedTab = filePage;
        }

        private void directoryTree_AfterSelect(object sender, TreeViewEventArgs e)
        {
            TreeNode node = directoryTree.SelectedNode;
            if (node != null)
            {
                DirectoryInfo d = (DirectoryInfo)node.Tag;

                if (node.Nodes.Count == 0)
                    ScanReal (node, d, 2);

                ScanFiles(d);
            }
            else
            {
                fileList.Items.Clear();
            }
        }

        private void fileList_ItemSelectionChanged(object sender, ListViewItemSelectionChangedEventArgs e)
        {
            foreach (ListViewItem item in fileList.SelectedItems)
            {
                FileInfo f = (FileInfo)item.Tag;
                MyPanel p = new MyPanel (area);
                TextBox t = new TextBox ();
                t.Text = "...";
                t.Multiline = true;
                p.Controls.Add (t);
                t.Dock = DockStyle.Fill;
                
            }
            tabControl2.SelectedTab = objectPage;

        }
    }



}
