﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace Kresleni
{
    public class MyArea
    {
        Okno window;

        TreeNode myPanelTreeNode = null;

        public MyArea(Okno p_win)
        {
            window = p_win;

            myPanelTreeNode = new TreeNode ();
            myPanelTreeNode.Text = "my panels";
            myPanelTreeNode.ToolTipText = "list of panels";
            // using System.Drawing;
            myPanelTreeNode.ForeColor = Color.CornflowerBlue;
            window.treeView1.Nodes.Add (myPanelTreeNode);
        }

        private void selectItem (object obj)
        {
            window.propertyGrid1.SelectedObject = obj;
        }

        private TreeNode registerItem (TreeNode top, object obj, string name)
        {
            TreeNode node = new TreeNode();
            node.Text = name;
            node.Tag = obj;
            if (top == null)
            {
                window.treeView1.Nodes.Add(node);
            }
            else
            {
                top.Nodes.Add(node);
                top.Expand();
            }
            return node;
        }

        int panel_cnt = 0;

        // MyPanel[] panels = new MyPanel[0];
        List <MyPanel> panels = new List <MyPanel> ();

        public void addMyPanel(MyPanel p)
        {
            window.pictureBox.Controls.Add(p);
            selectItem (p);

            // do konstruktoru tridy MyPanel
            // area.addMyPanel(this);

            panel_cnt ++;
            TreeNode top = 
                registerItem (myPanelTreeNode, p, "panel " + panel_cnt);
            top.ForeColor = Color.Orange;

            for (int i = 0; i < 4; i++)
            {
                window.pictureBox.Controls.Add(p.points[i]);
                TreeNode node = 
                   registerItem (top, p.points[i], "point " + (i+1));
                node.ForeColor = Color.Lime;
            }

            panels.Add(p);
            /*
            int n = panels.Length;
            MyPanel [] q = new MyPanel[n + 1];
            for (int i = 0; i < n; i++)
                q[i] = panels[i];
            q[n] = p;
            panels = q;
            */ 
        }

    }
}
