﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Kresleni
{
    public partial class MyPanel : UserControl
    {
        private MyArea area;

        public MyPoint [] points = new MyPoint[4];

        public MyPanel(MyArea p_area)
        {
            InitializeComponent();

            for (int i = 0; i < 4; i++)
                points[i] = new MyPoint();

            area = p_area;
            area.addMyPanel(this);

            points[0].Move += point0_move;
            points[3].Move += point3_move;

            MyPanel_Move (null, null);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (openDialog.ShowDialog() == DialogResult.OK)
            {
                Bitmap b = new Bitmap(openDialog.FileName);
                this.BackgroundImage = b;
                BackgroundImageLayout = ImageLayout.Stretch;
            }

        }

        int X0, Y0;
        bool stisknuto;

        private void MyPanel_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            stisknuto = true;
        }

        private void MyPanel_MouseMove(object sender, MouseEventArgs e)
        {
            if (stisknuto)
            {
                if (e.Button == MouseButtons.Left)
                {
                    int x = Location.X + e.X - X0;
                    int y = Location.Y + e.Y - Y0;
                    Location = new Point(x, y);
                }
                else if (e.Button == MouseButtons.Right)
                {
                    int w = Size.Width + e.X - X0;
                    int h = Size.Height + e.Y - Y0;
                    Size = new Size(w, h);
                    X0 = e.X;
                    Y0 = e.Y;
                }
            }
        }

        private void MyPanel_MouseUp(object sender, MouseEventArgs e)
        {
            stisknuto = false;
        }

        private void MyPanel_ParentChanged(object sender, EventArgs e)
        {
        }

        private void MyPanel_Move(object sender, EventArgs e)
        {
            MyPoint p = points[0];
            p.Left = Left - p.Width /2;
            p.Top = Top - p.Height / 2;
            // p.BringToFront();

            p = points[1];
            p.Left = Left + Width - p.Width / 2;
            p.Top = Top - p.Height / 2;

            p = points[2];
            p.Left = Left - p.Width / 2;
            p.Top = Top + Height - p.Height / 2;

            p = points[3];
            p.Left = Left + Width - p.Width / 2;
            p.Top = Top + Height - p.Height / 2;
        }

        private void point0_move (object sender, EventArgs e)
        {
            MyPoint p = points[0];
            Left = p.Left + p.Width / 2;
            Top = p.Top + p.Height / 2;
        }

        private void point3_move(object sender, EventArgs e)
        {
            MyPoint p = points[3];
            int w = p.Left + p.Width / 2 - Left;
            int h = p.Top + p.Height / 2 - Top;
            if (w > 0) Width = w;
            if (h > 0) Height = h;
        }

    }
}
